
#include <alloc_2d.h>

#include <check.h>
#include <stdio.h>
#include <stdlib.h>

START_TEST(alloc2d){
	size_t w = 5, h = 10;
	// NB the order of the for loops
	char **t1 = alloc2d_char(w, h);
	for (size_t i=0;i<h;i++){
		for (size_t j=0;j<w;j++){
			t1[i][j] = (i * w) + j;
		}
	}
	for (size_t i=0;i<h;i++){
		for (size_t j=0;j<w;j++){
			ck_assert_int_eq(t1[i][j], (i * w) + j);
		}
	}
	free2d_char(t1);
}
END_TEST

START_TEST(free_all){
	size_t w = 5, h = 10;
	// NB the order of the for loops
	char **t1 = (char**)malloc(w * sizeof(char*));
	for (size_t i=0;i<w;i++){
		t1[i] = (char*)malloc(h * sizeof(char));
	}
	for (size_t i=0;i<w;i++){
		for (size_t j=0;j<h;j++){
			t1[i][j] = (i * w) + j;
		}
	}
	for (size_t i=0;i<w;i++){
		for (size_t j=0;j<h;j++){
			fprintf(stdout, "%ld, %ld | %d == %ld\n", i, j, t1[i][j], (i * w) + j);
			ck_assert_int_eq(t1[i][j], (i * w) + j);
		}
	}
	free2d_all_char(t1, w);
}
END_TEST

Suite* stub_suite(void){
    Suite *s = suite_create("Stub");

    TCase *tc_core = tcase_create("Core");
    tcase_add_test(tc_core, alloc2d);
    tcase_add_test(tc_core, free_all);
    suite_add_tcase(s, tc_core);

    return s;
}

int main(int argc, char **argv){
    int number_failed;

    Suite *s = stub_suite();
    SRunner *sr = srunner_create(s);

    srunner_run_all(sr, CK_VERBOSE);
    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
}

